ITOOLSDIR = ../..

ALL: lib
#
IFILES    = -I$(ITOOLSDIR)
CFLAGS    = $(IFILES) $(COPT) $(OPT) 
FFLAGS    = $(OPT)
LIBBASE   = libpeblkcm$(COMM)
LIBS      = -L$(LDIR) -lpeblkcm$(COMM) -lpecomm$(COMM) -lpecore -lm 

SOURCEC   = arraychk.c cgrid.c gtol.c meshhelp.c 
SOURCEF   =
WSOURCEC  = arraychkf.c cgridf.c gtolf.c 
OBJSC     = arraychk.o cgrid.o gtol.o meshhelp.o
WOBJS     = arraychkf.o cgridf.o gtolf.o 
OBJSF     =
LOCAL_INCLUDE = ../bc.h ../bcp.h ../mesh.h
CLEANFILES = example example2 example3 test1

example: example.o lib
	$(CC) -o example $(CFLAGS) example.o $(LIBS) $(CLIB) $(SLIB)
	rm example.o
example2: example2.o lib
	$(CC) -o example2 $(CFLAGS) $(LOPT) example2.o $(LIBS) \
		$(CLIB) $(SLIB)
	rm example2.o
example3: example3.o lib
	$(CC) -o example3 $(CFLAGS) example3.o \
	$(LIBS) $(CLIB) $(SLIB)
	rm example3.o
dex2a: dex2a.o cutil.o lib
	$(FC) -o dex2a $(FFLAGS) $(BASEOPT) dex2a.o cutil.o \
	$(LIBS) $(CLIB) $(SLIB)
	rm dex2a.o
dex3: dex3.o cutil.o lib
	$(FC) -o dex3 $(FFLAGS) $(BASEOPT) dex3.o cutil.o \
	$(LIBS) $(CLIB) $(SLIB)
	rm dex3.o
super: super.o lib
	$(CC) -o super $(CFLAGS) $(CFLAGS) $(BASEOPT) super.c \
		$(LIBS) $(CLIB) $(SLIB)
	rm super.o
test1: test1.o 
	$(CC) -o test1 $(CFLAGS) test1.o $(LIBS) $(CLIB) $(SLIB)
	rm test1.o

############ makefile.tree
cctree: ccall
ccforttree: ccfort
cleantree: clean 
	@-if [ -n "$(EXAMPLE_DIRS)" ] ; then \
	for dir in $(EXAMPLE_DIRS) foo ; do if [ -s $$dir ] ; then \
	( cd $$dir ; echo $$dir ; $(MAKE) -f makefile cleantree ) ; fi ; \
	done ; fi

wrappers:
	-$(ITOOLSDIR)/c2fort/bfort -nomsgs -anyname -mapptr -I pubinc $(SOURCEC) $(SOURCEH)
manpages:
	-$(ITOOLSDIR)/doc/doctext -jumpfile $(ITOOLSDIR)/routine.list \
		-mpath $(ITOOLSDIR)/man/man`cat mansec` -ext `cat mansec`  \
		-I pubinc $(SOURCEC) $(SOURCEH)
	-$(ITOOLSDIR)/doc/doc2lt $(SOURCEC) $(SOURCEH) >> \
		$(ITOOLSDIR)/docs/rsum/rsum`cat mansec`.tmp
############ makefile.tree

LDIR    = $(ITOOLSDIR)/libs/libs$(BOPT)/$(ARCH)
LIBNAME = $(LDIR)/$(LIBBASE).a
SOURCE  = $(SOURCEC) $(SOURCEF)
OBJS    = $(OBJSC) $(OBJSF)
SHELL   = /bin/sh
TOOLARCH = $(ARCH)

include $(ITOOLSDIR)/bmake/$(ARCH).x11
include $(ITOOLSDIR)/bmake/$(ARCH).$(BOPT)
include $(ITOOLSDIR)/bmake/$(ARCH)
include $(ITOOLSDIR)/bmake/$(ARCH).$(COMM)

$(LIBNAME)($(OBJS)): $(LOCAL_INCLUDE)

ccall: ccbuild
	$(RANLIB) $(LIBNAME)
ccbuild:
	-$(CC) -c $(CDEFS) $(CFLAGS) $(BASEOPT) -I$(ITOOLSDIR) $(SOURCEC)
	if [ "$(SOURCEF)" != "" ] ; then \
	    $(FC) -c $(FFLAGS) $(BASEOPTF) $(SOURCEF) ; \
	fi
	$(AR) clr $(LIBNAME) $(OBJS)
	$(RM) $(OBJS)
ccfort:
	@-if [ -n "$(WOBJS)" ] ; then \
	$(CC) -c $(CDEFS) $(CFLAGS) $(BASEOPT) -I$(ITOOLSDIR) $(WSOURCEC) ; \
 	$(AR) clr $(LDIR)/libpetscfort$(COMM).a $(WOBJS) ; \
	$(RM) $(WOBJS) ; \
	fi
clean:
	-/bin/rm -f *.o *~ $(CLEANFILES)
