ITOOLSDIR = /home/gropp/tools.n

ITOOLSDIR = ../..

ALL:  example1.$(ARCH) example2.$(ARCH) example3.$(ARCH) ring pi example4 \
      lapc wavec lapf wavef

CFLAGS    = -I$(ITOOLSDIR) $(OPT) $(COPT) $(X11INCLUDEDIR)
FFLAGS    = -I$(ITOOLSDIR)
LIBS      = -L$(LDIR) -lpecomm$(COMM) -lpetsc -lpecore -lpecomm$(COMM)
FLIBS     = -L$(LDIR) -lpetscfort$(COMM) -lpetscfort
FMAIN     = $(LDIR)/fmain$(COMM).o
CMAIN     = $(LDIR)/cmain$(COMM).o
LXLIBS    = -L$(LDIR) -lpetscgrf$(COMM) -lpetscgrf 
CLEANFILES = expicl lapc lapf wavec wavef argtest pi ring ring2 long *.o \
	PIa* example[123].$(ARCH) example4

LIBBASE = dummy

EXAMPLE_DIRS = perf angst

example_progs: example1.$(ARCH) example2.$(ARCH) example3.$(ARCH) \
	  example4 ring expicl 
	(cd angst ; make -f makefile example_progs )
run_examples: example_progs
	example1.$(ARCH) -np 4 -mem 4 -listnodes
	example2.$(ARCH) -np 2 -mem 4 -listnodes
	example3.$(ARCH) -np 4 -mem 4 -listnodes
	example4 -np 4 -mem 4 -listnodes
	ring -np 2 -mem 4 -listnodes
	if [ -x expicl ] ; then \
	expicl -np 2 -mem 4 ; fi
	(cd angst ; make -f makefile run_examples )
test_progs:
run_tests:

example1.$(ARCH): example1.o
	$(CLINKER) -o example1.$(ARCH) $(CFLAGS) $(BASEOPT) example1.o \
		$(LIBS) $(CLIB) $(SLIB) -lm

example2.$(ARCH): example2.o
	$(FLINKER) -o example2.$(ARCH) $(BASEOPTF) example2.o $(FMAIN) \
		$(FLIBS) $(LIBS) $(CLIB) $(SLIB) -lm

example4: example4.o
	$(FLINKER) -o example4 $(BASEOPTF) example4.o $(FMAIN) \
		$(FLIBS) $(LIBS) $(CLIB) $(SLIB) -lm

expicl: expicl.o
	if [ -s $(LDIR)/picl2comm$(COMM).o ] ; then \
	$(FLINKER) -o expicl $(BASEOPTF) expicl.o $(FMAIN) \
	   $(LDIR)/picl2comm$(COMM).o $(FLIBS) $(LIBS) $(CLIB) $(SLIB) -lm ; fi

pi: pi.o
	$(FLINKER) -o pi $(BASEOPTF) pi.o \
		$(FLIBS) $(LIBS) $(CLIB) $(SLIB) -lm

grayex: grayex.o
	$(CLINKER) -o grayex $(BASEOPTF) grayex.o \
		$(FLIBS) $(LIBS) $(SLIB) -lm

eui: eui.o
	$(CLINKER) -o eui $(BASEOPTF) eui.o 

example3.$(ARCH): example3.o
	$(CLINKER) -o example3.$(ARCH) $(CFLAGS) $(BASEOPT) example3.o \
		$(LIBS) $(CLIB) $(SLIB) -lm

exscat.$(ARCH): exscat.o
	$(CLINKER) -o exscat.$(ARCH) $(CFLAGS) $(BASEOPT) exscat.o \
		$(LIBS) $(CLIB) $(SLIB) -lm

buggy: buggy.o
	$(CLINKER) -o buggy $(CFLAGS) $(BASEOPT) $(CMAIN) buggy.o \
		$(LIBS) $(CLIB) $(SLIB) -lm

ptest: ptest.o
	$(CLINKER) -o ptest $(CFLAGS) $(BASEOPT) $(CMAIN) ptest.o \
		$(LIBS) $(CLIB) $(SLIB) -lm

ring: ring.o
	$(CLINKER) -o ring $(CFLAGS) $(BASEOPT) $(CMAIN) ring.o \
		$(LIBS) $(CLIB) $(SLIB) -lm
long: long.o
	$(CLINKER) -o long $(CFLAGS) $(BASEOPT) $(CMAIN) long.o \
		$(LIBS) $(CLIB) $(SLIB) -lm
ring2: ring2.o
	$(CLINKER) -o ring2 $(CFLAGS) $(BASEOPT) $(CMAIN) ring2.o \
		$(LIBS) $(CLIB) $(SLIB) -lm
wavec: wavec.o
	$(CLINKER) -o wavec $(CFLAGS) $(BASEOPT) $(LDIR)/cmain$(COMM).o \
                   wavec.o $(LXLIBS) $(LIBS) $(CLIB) $(SLIB) $(X11LIB) -lm
 
wavef: wavef.o 
	$(FLINKER) -o wavef $(FFLAGS) $(BASEOPTF) $(LDIR)/fmain$(COMM).o \
                   wavef.o $(FLIBS) $(LXLIBS) $(LIBS) $(CLIB) $(SLIB) $(X11LIB) -lm

lapc: lapc.o  
	$(CLINKER) -o lapc $(CFLAGS) $(BASEOPT) $(LDIR)/cmain$(COMM).o \
                  lapc.o $(LXLIBS) $(LIBS) $(CLIB) $(SLIB) $(X11LIB) -lm

lapf: lapf.o 
	$(FLINKER) -o lapf $(FFLAGS) $(BASEOPTF) $(LDIR)/fmain$(COMM).o \
                lapf.o $(FLIBS) $(LXLIBS) $(LIBS) $(CLIB) $(SLIB) $(X11LIB) -lm

argtest: argtest.o
	$(CLINKER) -o argtest $(CFLAGS) $(BASEOPT) $(LDIR)/cmain$(COMM).o \
                  argtest.o $(LXLIBS) $(LIBS) $(CLIB) $(SLIB) $(X11LIB) -lm

############ makefile.tree
cctree: ccall
ccforttree: ccfort
cleantree: clean 
	@-if [ -n "$(EXAMPLE_DIRS)" ] ; then \
	for dir in $(EXAMPLE_DIRS) foo ; do if [ -s $$dir ] ; then \
	( cd $$dir ; echo $$dir ; $(MAKE) -f makefile cleantree ) ; fi ; \
	done ; fi

wrappers:
manpages:
	-$(ITOOLSDIR)/doc/doctext -jumpfile $(ITOOLSDIR)/routine.list \
		-mpath $(ITOOLSDIR)/man/man`cat mansec` -ext `cat mansec`  \
		$(ITOOLSDIR)/docs/rsum/rsum`cat mansec`.tmp
############ makefile.tree

LDIR    = $(ITOOLSDIR)/libs/libs$(BOPT)/$(ARCH)
LIBNAME = $(LDIR)/$(LIBBASE).a
SHELL   = /bin/sh
TOOLARCH = $(ARCH)

include $(ITOOLSDIR)/bmake/$(ARCH).x11
include $(ITOOLSDIR)/bmake/$(ARCH).$(BOPT)
include $(ITOOLSDIR)/bmake/$(ARCH)
include $(ITOOLSDIR)/bmake/$(ARCH).$(COMM)


ccall: ccbuild
	$(RANLIB) $(LIBNAME)
ccbuild:
	if [ "$(SOURCEF)" != "" ] ; then \
	    $(FC) -c $(FFLAGS) $(BASEOPTF) $(SOURCEF) ; \
	fi
ccfort:
	@-if [ -n "$(WOBJS)" ] ; then \
	$(RM) $(WOBJS) ; \
	fi
clean:
	-/bin/rm -f *.o *~ $(CLEANFILES)
