ITOOLSDIR = ../../..

ALL:  mpptest

CFLAGS    = -I$(ITOOLSDIR) $(OPT) $(COPT) $(X11INCLUDEDIR)
FFLAGS    = -I$(ITOOLSDIR)
LIBS      = -L$(LDIR) -lpecomm$(COMM) -lpetsc -lpecore
FMAIN     = $(LDIR)/fmain$(COMM).o
CMAIN     = $(LDIR)/cmain$(COMM).o
LXLIBS    = -lpetscgrf$(COMM) -lpetscgrf
CLEANFILES = mpptest goptest *.o

LIBBASE = dummy

MPOBJS  = pair.o grph.o ovlap.o util.o gopf.o pattern.o
GOPOBJS = grph.o util.o gopf.o
mpptest: mpptest.o $(MPOBJS)
	$(CLINKER) -o mpptest $(CFLAGS) $(BASEOPT) $(CMAIN) \
		mpptest.o $(MPOBJS) \
		$(LIBS) $(CLIB) $(SLIB) -lm
goptest: goptest.o $(GOPOBJS)
	$(CLINKER) -o goptest $(CFLAGS) $(BASEOPT) $(CMAIN) \
		goptest.o $(GOPOBJS) \
		$(LIBS) $(CLIB) $(SLIB) -lm
############ makefile.tree
cctree: ccall
ccforttree: ccfort
cleantree: clean 
	@-if [ -n "$(EXAMPLE_DIRS)" ] ; then \
	for dir in $(EXAMPLE_DIRS) foo ; do if [ -s $$dir ] ; then \
	( cd $$dir ; echo $$dir ; $(MAKE) -f makefile cleantree ) ; fi ; \
	done ; fi

wrappers:
manpages:
	-$(ITOOLSDIR)/doc/doctext -jumpfile $(ITOOLSDIR)/routine.list \
		-mpath $(ITOOLSDIR)/man/man`cat mansec` -ext `cat mansec`  \
		$(ITOOLSDIR)/docs/rsum/rsum`cat mansec`.tmp
############ makefile.tree

LDIR    = $(ITOOLSDIR)/libs/libs$(BOPT)/$(ARCH)
LIBNAME = $(LDIR)/$(LIBBASE).a
SHELL   = /bin/sh
TOOLARCH = $(ARCH)

include $(ITOOLSDIR)/bmake/$(ARCH).x11
include $(ITOOLSDIR)/bmake/$(ARCH).$(BOPT)
include $(ITOOLSDIR)/bmake/$(ARCH)
include $(ITOOLSDIR)/bmake/$(ARCH).$(COMM)


ccall: ccbuild
	$(RANLIB) $(LIBNAME)
ccbuild:
	if [ "$(SOURCEF)" != "" ] ; then \
	    $(FC) -c $(FFLAGS) $(BASEOPTF) $(SOURCEF) ; \
	fi
ccfort:
	@-if [ -n "$(WOBJS)" ] ; then \
	$(RM) $(WOBJS) ; \
	fi
clean:
	-/bin/rm -f *.o *~ $(CLEANFILES)
