/* pio.c */
/* Fortran interface file */
#include "tools.h"
#include "comm/comm.h"
#include "comm/io/pio.h"
#include <stdio.h>

#ifdef POINTER_64_BITS
extern void *__ToPointer();
extern int __FromPointer();
extern void __RmPointer();
#else
#define __ToPointer(a) (a)
#define __FromPointer(a) (int)(a)
#define __RmPointer(a)
#endif

#ifdef FORTRANCAPS
#define pifopen_ PIFOPEN
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pifopen_ pifopen
#endif
 int pifopen_( name, procset, mode, pmode, fmode)
char    *name;
ProcSet *procset;
int*mode,*pmode,*fmode;
{
return __FromPointer( (void *)( PIFopen(name,
	(ProcSet* )__ToPointer( *(int*)(procset) ),*mode,*pmode,*fmode) ));
}
#ifdef FORTRANCAPS
#define piwritecommon_ PIWRITECOMMON
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define piwritecommon_ piwritecommon
#endif
 void  piwritecommon_( fp, fmat, flen, v, n, datatype)
PIFILE *fp;
char   *fmat;
void   *v;
int*flen,*n,*datatype;
{
PIWriteCommon(
	(PIFILE* )__ToPointer( *(int*)(fp) ),fmat,*flen,v,*n,*datatype);
}
#ifdef FORTRANCAPS
#define pireadcommon_ PIREADCOMMON
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pireadcommon_ pireadcommon
#endif
 void  pireadcommon_( fp, fmat, flen, v, n, datatype)
PIFILE *fp;
char   *fmat;
void   *v;
int*flen,*n,*datatype;
{
PIReadCommon(
	(PIFILE* )__ToPointer( *(int*)(fp) ),fmat,*flen,v,*n,*datatype);
}
#ifdef FORTRANCAPS
#define piwritedistributedarray_ PIWRITEDISTRIBUTEDARRAY
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define piwritedistributedarray_ piwritedistributedarray
#endif
 void  piwritedistributedarray_( fp, fmat, flen, sz, nd, v, datatype)
PIFILE      *fp;
char        *fmat;
void        *v;
PIArrayPart *sz;
int*flen,*nd,*datatype;
{
PIWriteDistributedArray(
	(PIFILE* )__ToPointer( *(int*)(fp) ),fmat,*flen,
	(PIArrayPart* )__ToPointer( *(int*)(sz) ),*nd,v,*datatype);
}
#ifdef FORTRANCAPS
#define pireaddistributedarray_ PIREADDISTRIBUTEDARRAY
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pireaddistributedarray_ pireaddistributedarray
#endif
 void  pireaddistributedarray_( fp, fmat, flen, sz, nd, v, datatype)
PIFILE      *fp;
char        *fmat;
void        *v;
PIArrayPart *sz;
int*flen,*nd,*datatype;
{
PIReadDistributedArray(
	(PIFILE* )__ToPointer( *(int*)(fp) ),fmat,*flen,
	(PIArrayPart* )__ToPointer( *(int*)(sz) ),*nd,v,*datatype);
}
#ifdef FORTRANCAPS
#define pifclose_ PIFCLOSE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pifclose_ pifclose
#endif
 void  pifclose_( fp)
PIFILE *fp;
{
PIFclose(
	(PIFILE* )__ToPointer( *(int*)(fp) ));
}
#ifdef FORTRANCAPS
#define pifflush_ PIFFLUSH
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pifflush_ pifflush
#endif
 void  pifflush_( fp)
PIFILE *fp;
{
PIFflush(
	(PIFILE* )__ToPointer( *(int*)(fp) ));
}
