#ifndef lint
static char vcid[] = "$Id: piunix.c,v 1.3 1995/02/13 16:43:24 gropp Exp $";
#endif

#include <stdio.h>
#include <ctype.h>
#if defined(cray)
#include <errno.h>
#else
extern int errno;
#endif
#include <sys/errno.h>
#include "tools.h"
#include "comm/comm.h"
#include "comm/io/pio.h"
#ifndef SEEK_SET
#include <unistd.h>
#endif

/* #if !defined(rs6000) */
extern int lseek();
/* #endif */

extern int read(), write();

#if defined(intelparagon)
extern long _cread(), _cwrite();
#elif defined(intelnx)
extern int cread(), cwrite();
#endif

/* 
   Default read, write, and seek routines.  These are simple versions
   of read, write, and lseek, but they take a PIFILE instead of an fd.
   This allows us to replace these routines with cached varieties.

   They ALSO handle EINTR
 */
int PIiDefRead( fp, buffer, len )
PIFILE *fp;
char   *buffer;
int    len;
{
int err;

#if defined(intelnx)
err = cread( fp->fd, buffer, len );
#else
while (1) {
    err = read( fp->fd, buffer, len );
    if (err < 0 && errno == EINTR) continue;
    if (err < 0) {
	SETERRC( 1, "Error in reading from file" );
	return -1;
	}
    break;
    }
#endif
return err;
}

int PIiDefWrite( fp, buffer, len )
PIFILE *fp;
char   *buffer;
int    len;
{
int err;

#if defined(intelnx)
err = cwrite( fp->fd, buffer, len );
#else
while (1) {
    err = write( fp->fd, buffer, len );
    if (err < 0 && errno == EINTR) continue;
    if (err != len) {
	if (errno == ENOSPC) {
	    SETERRC( 1, "Error in writing to file; no space left" );
	    }
	else {
	    SETERRC( 1, "Error in writing to file" );
	    perror( (char *)0 );
	    }
	return -1;
	}
    break;
    }
#endif
return err;
}
int PIiDefFlush( fp )
PIFILE *fp;
{
return 0;
}
int PIiDefLseek( fp, offset, whence, rw )
PIFILE *fp;
int    offset, whence, rw;
{
lseek( fp->fd, offset, whence );
}

int PIiDefClose( fp )
PIFILE *fp;
{
close( fp->fd );
}

int PIiDefOpen( fp, name, mode, fmode )
PIFILE *fp;
char   *name;
int    mode, fmode;
{
fp->fd = open( name, mode, fmode );
}

extern int PIiOpenEach ANSI_ARGS(( char *, ProcSet, int, int, int ));

/* @
   PIUnixCreate - Creates a context containing the routines for 
   using regular Unix operations.

   Returns:
   Pointer to PIFileOps context.
@ */
PIFileOps *PIUnixCreate()
{
PIFileOps *new;

new = NEW(PIFileOps);   CHKPTRN(new);
new->basewriter	   = PIiDefWrite;
new->basereader	   = PIiDefRead;
new->baselseek	   = PIiDefLseek;
new->baseflush	   = PIiDefFlush;
new->baseopen	   = PIiDefOpen;
new->baseclose	   = PIiDefClose;
new->baseopenlocal = PIiOpenEach;

return new;
}
