/* procset.c */
/* Fortran interface file */
#include "tools.h"
#include "comm/comm.h"

#ifdef POINTER_64_BITS
extern void *__ToPointer();
extern int __FromPointer();
extern void __RmPointer();
#else
#define __ToPointer(a) (a)
#define __FromPointer(a) (int)(a)
#define __RmPointer(a)
#endif

#ifdef FORTRANCAPS
#define pscreate_ PSCREATE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pscreate_ pscreate
#endif
 int pscreate_( name)
int*name;
{
return __FromPointer( (void *)( PSCreate(*name) ));
}
#ifdef FORTRANCAPS
#define psdestroy_ PSDESTROY
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define psdestroy_ psdestroy
#endif
 void  psdestroy_( procset)
ProcSet *procset;
{
PSDestroy(
	(ProcSet* )__ToPointer( *(int*)(procset) ));
}
#ifdef FORTRANCAPS
#define psaddmember_ PSADDMEMBER
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define psaddmember_ psaddmember
#endif
 void  psaddmember_( procset, p, np)
ProcSet *procset;
int     *p,*np;
{
PSAddMember(
	(ProcSet* )__ToPointer( *(int*)(procset) ),p,*np);
}
#ifdef FORTRANCAPS
#define pssetmeshsize_ PSSETMESHSIZE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pssetmeshsize_ pssetmeshsize
#endif
 void  pssetmeshsize_( procset, nx, ny)
ProcSet *procset;
int*nx,*ny;
{
PSSetMeshSize(
	(ProcSet* )__ToPointer( *(int*)(procset) ),*nx,*ny);
}
#ifdef FORTRANCAPS
#define pscompile_ PSCOMPILE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pscompile_ pscompile
#endif
 void  pscompile_( procset)
ProcSet *procset;
{
PSCompile(
	(ProcSet* )__ToPointer( *(int*)(procset) ));
}
#ifdef FORTRANCAPS
#define pspartition_ PSPARTITION
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pspartition_ pspartition
#endif
 int pspartition_( pval, procset)
int*pval;
ProcSet *procset;
{
return __FromPointer( (void *)( PSPartition(*pval,
	(ProcSet* )__ToPointer( *(int*)(procset) )) ));
}
#ifdef FORTRANCAPS
#define psunion_ PSUNION
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define psunion_ psunion
#endif
 int psunion_( ps1, ps2, name)
ProcSet *ps1, *ps2;
int*name;
{
return __FromPointer( (void *)( PSUnion(
	(ProcSet* )__ToPointer( *(int*)(ps1) ),
	(ProcSet* )__ToPointer( *(int*)(ps2) ),*name) ));
}
#ifdef FORTRANCAPS
#define pigettags_ PIGETTAGS
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pigettags_ pigettags
#endif
 int  pigettags_( procset, n)
ProcSet *procset;
int*n;
{
return PIGetTags(
	(ProcSet* )__ToPointer( *(int*)(procset) ),*n);
}
#ifdef FORTRANCAPS
#define pireturntags_ PIRETURNTAGS
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define pireturntags_ pireturntags
#endif
 void  pireturntags_( procset, n, ltag)
ProcSet *procset;
int*n,*ltag;
{
PIReturnTags(
	(ProcSet* )__ToPointer( *(int*)(procset) ),*n,*ltag);
}
