
/*
    Some macros for compiling code that runs for either double or
  double complex.

*/
#if !defined(__CPLXUTIL)
#define __CPLXUTIL

#if defined(PETSC_COMPLEX)
#define Scalar         dcomplex
#define SET(a,s,j)     (a).r = s; (a).i = j;
#define REALPART(a)    (a).r
#define REALPARTP(a)   (a)->r
#define IMAGPART(a)    (a).i
#define IMAGPARTP(a)   (a)->i
#else
#define Scalar         double
#define SET(a,s,j)     a = s;
#define REALPART(a)    a
#define REALPARTP(a)   *(a)
#define IMAGPART(a)    0.0
#define IMAGPARTP(a)   0.0
#endif

#endif

