.TH InstallingTools.Old r "1/3/1995" " " "PETSc"
.SH NAME
InstallingTools.Old \- old procedure for installing the tools

.br
  **********************************************************************
.br
.br
  OLD INSTRUCTIONS  
.br
.br
  THESE SHOULD STILL WORK, BUT WE SUGGEST USING 
.br
  CONFIGURE INSTEAD.
.br
.br
  See InstallingTools for information on the new 
.br
  configure installation process.
.br
.br
  **********************************************************************

All pathnames in this document are relative to the root directory for
the entire PETSc library (usually something like "tools" or "tools.core").
You should set the environmental variable TOOLSDIR to the location of
the root directory of PETSc, for instance
.br
.br
      setenv TOOLSDIR /home/bsmith/tools
.br
If you wish to use pvm or p4 or both you should set the
environment variables PVMDIR and P4DIR to point to their root
directories, for instance
.br
  setenv PVMDIR /home/bsmith/pvm
.br
  setenv P4DIR /home/bsmith/p4

Note that these should be the "roots" of the PVM and P4 directories.

You can use the environment variable P4LIBDIR to set the directory that
contains the p4 library; for instance,
.br
  setenv P4LIBDIR /usr/local/p4/SUN
.br
  (note that the library will be searched for in $P4LIBDIR/lib/libp4.a)
You need this only if your P4 libraries are not in the expected places.

You can use the environment variable PVMLIBDIR to set the directory that
contains the library (libpvm.a for pvm 2.4.x, libpvm3.a for pvm 3.x);
for instance,
.br
  setenv PVMLIBDIR /usr/local/pvm3/lib/RS6K
You need this only if your PVM libraries are not in the expected places.


For pvm and pvm3 in particular, you may need to setup links to the
appropriate places.  Currently,

If you have the BLAS or LAPACK available, you should indicate where they
are by setting TOOLSBLAS and TOOLSLAPACK respectively, for instance
.br
  setenv TOOLSBLAS   /usr/local/lib/libblas.a
.br
  setenv TOOLSLAPACK /usr/local/lib/liblapack.a

You need to generate a "hosts" file in ./comm .  This file contains
the names of machines, their "owners", and some resource limits.
This allows people to allow their machines to be used in the evening
but not during the day, or for short amounts of time in the day
and longer ones in the evening. Update $TOOLSDIR/comm/hosts to include
machines at your site.

The pvm hosts file is in $TOOLSDIR/comm/pvmhosts; you can use the
environment variable TOOLSPVMHOSTS to specify another file.

.SH FIRST INSTALLATION
Run $TOOLSDIR/bin/inscheck .  This will give you some idea of what
will be built (for example, if you have LAPACK available, make sure
that this says that it will use the system LAPACK).  For example, on
one of our systems, the output from inscheck is

.br
   Will NOT use lock mechanism to allow multiple simultaneous installs
.br
   Using /usr/local/p4-1.2/SUN as the library for P4
.br
   The root directory for PETSc is /home/gropp/tools.core
.br
   X11 includes are in /usr/include/X11
.br
   X11 libs found
.br
   Using /usr/local/lapack/lib/lapack.a as the library for LAPACK
.br
   Using /usr/local/lapack/lib/blas.a as the library for level 1-3 BLAS

This says that the install will use system versions of LAPACK and the
BLAS, that X11 was found, and that P4 was found.  Once the output from
inscheck is satisfactory, you can proceed to install the code.

Run $TOOLSDIR/bin/install. This will compile the code.  You must run
this from $TOOLSDIR (the root of the tools directory).  The usual
commands are

.br
  cd $TOOLSDIR
.br
  bin/install >&tools.log &

This will build the object libraries and the man pages.
You should check the output of this build for any errors.  If you pipe
the output to a file, say "tools.log", then you can look for error
messages with
.br
       $TOOLSDIR/bin/finderrors tools.log
This looks for compile and archive errors in the output by searching for
special character patterns in the log file.

.SH CROSS COMPILATIONS
For the Intel i860, Delta, and Paragon, and the TMC CM-5,
cross-compilations are performed.  Note that for the Paragon, you can
compile directly on the Paragon; to do this you should replace
bmake/paragon with bmake/paragon.nox.  (nox is "No-Cross")
Note that "paragon" is a different architecture type from intelnx;
"inteldelta" is also different from intelnx.

One problem that can come up during cross-compilations is that some of the
features of tools.core are built during the installation process.  You may
need to build a subset of tools.core for the architecture on which you are
cross-compiling.  To do this, do
.br
      cd system
.br
      make BOPT=g ARCH=sun4
.br
  (on a sun4 system).  Do this only if you have problems during the 
installation.

.SH SPECIAL NOTE
For the intel Delta, you must do
.br
       bin/install inteldelta <other options>
This distinguishes between the Delta (a mesh) and the ipsc/i860s
(a hypercube).

.SH SUNMOS FOR THE INTEL PARAGON
SUNMOS provides an alternate operating system for Intel paragons.  To
build the libraries for this version, first use architecture paragon.
Once the paragon build has succeeded, do

.br
   foreach dir (libs/* fort) 
.br
       ( cd $dir ; ln -s paragon sunmos-pgon )
.br
   end
.br
Then use the architecture type "sunmos-pgon" when making programs for
SUNMOS.

.SH BUILDING DOCUMENTATION
$TOOLSDIR/bin/buildman will generate the man pages in ./man , as well
as building the "whatis" file (used for man -k).  This needs to build
a program in ./doc . $TOOLSMAN/bin/toolman under X-windows will bring
up an interface to all the manual pages for PETSc.
You can pass toolman additional arguments; for example,
.br
  $TOOLSDIR/bin/toolman -pagesize 630x760 
will change the size of the manual page.

In addition, this will build summary files (in ./docs).  This is a LaTeX
file that may be used to generate a table of routine names, calling
sequences, and short descriptions.  "make functions.dvi" in ./docs will
build the dvi file for this listing; "make print" will print a copy (
assuming that you have dvips.  Otherwise, use your dvi-to-ps converter.)

Reference manuals for the entire library can also be built.  First,
run bin/buildref from the $TOOLSDIR directory.  The reference manual
for the entire library may be built with "make allrefs"; for SLES with
"make slesref", and for Chameleon with "make parref".  All of these are
from $TOOLSDIR/docs .  A simple "make" in this directory will build all
of the documents (once buildref has been run).

You must run bin/buildman from $TOOLSDIR (the root of the PETSc directory).

.SH BUILDING DOCUMENTATION BEFORE BUILDING THE WHOLE PACKAGE
It is possible to build the documentation without building the entire
package.  Do the following

.br
  cd tools.core
.br
  set myarch = `bin/tarch`
.br
  mkdir libs
.br
  mkdir libs/libsg
.br
  mkdir libs/libsg/$myarch
.br
  cd system
.br
  make ARCH=$myarch BOPT=g
.br
  cd ../doc
.br
  make
.br
  cd ..
.br
  bin/buildman
.br
This should get you started.

.SH BUILDING EXAMPLES
$TOOLSDIR/bin/buildex [-g -Opg or -O] [ -comm p4 or -comm pvm] will
build and test run all the examples. (Don't be surprised if all the
examples don't run.  Before running the examples make sure that
the p4 and pvm libraries for the architecture are built.)

You must run this from $TOOLSDIR (the root of the PETSc directory).

If you building cross-compiled versions (for example, for an Intel i860),
you need to add the option "ARCH name".  For example, "ARCH intelnx".

.SH CURRENT INFORMATION
Our WWW site http://www.mcs.anl.gov has pointers to PETSc; in the PETSc
page is a pointer to the current status, including known problems and
recent changes.

.SH POSSIBLE PROBLEMS

.br
  "Can not determine architecture type"
.br
  The install script could not find the architecture type for your machine
by using /bin/arch or /bin/uname.  This should not happen for any
of the supported architectures

.br
  "<name> is not a supported architecture"
.br
  PETSc uses a series of makefile includes to customize the makes for 
each architecture; install could not find the ones that it needs.
Look at bmake/sun4* for some examples; the name used should be
the same as that returned by /bin/arch or /bin/uname.

.br
  "install did not build the intelnx (hypercube and delta) versions."
.br
  PETSc looks for the presence of the cross-compiler before attempting
this.  Currently, it looks in $PGI/i860/bin.<local-architecture> .
You may need to change this test for different locations of the
cross-compiler.  In addition, the environment variable PGI needs
to be set appropriately (this means that it needs to be set
to the correct directory, and should be set in your .cshrc file
to insure that the correct value is propagated to the shell that
executes the compiler).

.br
  "install seems hung."
.br
  Install uses a mechanism for insuring that only one install program is
processing a directory at any time.  This allows multiple install
scripts, each running for a different architecture, to run in parallel.
This is managed by adding files with names INSTALL* to the directory
being processed.  If an install aborts for any reason, these files
may be left in the directories.  To remove them all, use the command
.br
  find . -name 'INSTALL*' -exec /bin/rm \\{\\} \\;
.br
  The file contains the name of the architecture that generated it.

Note that by default, this mechanism is not used.  However, if TOOLSLOCK
has the value "YES", then it will attempt to lock access to the
directories.

.br
  "Make always makes every component in the library."
.br
  Unfortunately, early versions of "make" did not support libraries very
well, and different vendors added different extensions.  We have tried to
accommodate these through the make patterns in the ./bmake directory,
but on some systems we were unable to convince make (even gnumake!)
to operate as we would have liked.  The Alliant fx2800 is one of these
systems.  gnumake seems to be unable to properly manage libraries; if you
use gnumake instead of the vendor's make, you may want to temporarily
switch back to the vendor's version.

.br
  "Can not build routines in xtools."
.br
  If the include files or libraries are not where they are expected, 
these routines (naturally) can not be built.  To get these files
to compile, add
.br
       X11INCLUDEDIR = -Idirectory_name
.br
  to bmake/ARCH.  For example, if your X11 include files are in 
/usr/local/include, and you are building these for a sun4, then add
.br
       X11INCLUDEDIR = -I/usr/local/include
.br
  to $TOOLSDIR/bmake/sun4 .  You will also have to modify bin/buildlib
to change the test for the X11 include libraries.

.br
  "Need to build the libraries without modifying existing ones."
.br
  You can use the -finaldir <directoryname> argument to bin/install 
give the name of the directory where the code will eventually be
installed.  For example, if the installed directory is /home/me/tools.core,
then do the following to install a new version with the minimum
impact on current users.
.br
      unpack the new tools.core into, e.g., tools.new
.br
      cd tools.new
.br
      bin/install -finaldir /home/me/tools.core >& install.log 
.br
      <when done>
.br
      cd ..
.br
      mv tools.core tools.core.old
.br
      mv tools.new  tools.core

.br
  "Building for the CM5 fails with an unknown include file."
.br
  Every version of CMMD (the message passing library) for the CM5 has
some incompatibilities with the other versions.  By default, version
two is tried.  You can edit bmake/cm5 and change the value of
CMMDVersion to 3 and try again.  If that doesn't work, contact
gropp@mcs.anl.gov with the error message and be prepared to give access
to your system.

.br
  "Some files were changed but not rebuilt"
.br
  The make programs on some systems can not correctly handle dependencies
with library files.  The only safe thing to do here is to delete the
libraries and rebuild everything.

.br
  "The Fortran examples do not build when I copy them"
.br
  They may use the non-standard statement 'include "file.h"'  To fix this, 
either copy the include file into the same directory as your source file,
make a link (ln -s ...) to it, or edit the source file to give an
absolute path name for the include statement.

.br
  The intelnx build give errors like
.br
  PGC-W-0114-More than one type specified ...
.br
  This is a bug in the Intel include files.  There is a include/time.h
and an include-i860/sys/types.h which have incompatible definitions.
There isn't anything that you can do about it other than submit a
bug report to Intel.

The Paragon has the same problem.

There is a similar problem with SEEK_SET, SEEK_CUR, and SEEK_END.

.br
  The IBM build gives errors like
."/home/gropp/tools.n/comm/commeui.h", line 27.1: 1506-137 (S) 
.br
Previous declaration must declare at least one declarator, tag, or 
.br
the members of an enumeration.
.br
  This is caused by a conflict with the typedef of ulong in commeui.h
Normally, you should not get this; however, if you use your own (rather
than the PETSc) makefiles, make sure that you include -D_POSIX_SOURCE
as an option to the C compiler.

.br
  "I can not compile for rs6000 using xlf and xlc."
.br
  You may have out-of-date versions of these compilers.  Try to update them.
If that doesn't work, change the references in tools.core/bmake/rs6000*
of xlc to cc and xlf to f77 and try again.


.SH LOCATION
 readme
