.TH Porting r "1/3/1995" " " "PETSc"
.SH NAME
Porting \- This attempts to provide an outline of how to port PETSc
to another architecture. Warning, since unix is far from standardized and
parallel computers are even less so; porting PETSc to another
architecture may range widely in difficulty.

1) Choose a name for the architecture. This should be short, likely
to be unique, (for instance, don't use RISC or IBM), and related to
the actual machine. Use just numbers and letters; use no special
charactors.  All machines that are binary compatiable should have the
same arch, for instance the Sparc1, Sparc1+ and Sparc2 all have the
arch, sun4. The standard unix command "uname -m" may be a good place to
get the name from.

2) Create files in bmake called arch, arch., arch.O, arch.g, arch.Opg,
containing the compiler names; locations of system libraries, etc.
You can start by modifying the sun4 versions.

3) Modify bin/tarch to deal with the new arch.

4) Add the arch to comm/hosts.h

5) Add the new arch to comm/hosts.c (two places)

6) Add the new arch to system/arch.c

7) If the new architecture supports PVM; determine the PVM name
for the architecture and add the correspondence between your
arch and the PVM arch into comm/initpvm.c and bin/install

8) If the new architecture supports p4; determine the p4 name
for the architecture and add it to bin/install

9) Try installing PETSc with
.br
        bin/install myarch -libs g >& myarch.log
.br
   where "myarch" is the new architecture.

Different Unix versions have different include files, different ways
of dealing with floating point exceptions, etc. All you can do
now is try a build and fix any problems that come up doing compilation.

.SH MESSAGE PASSING SYSTEMS
PETSc can also be modified to run with different message passing
systems. This is a bigger project; most of the changes, however, are
restricted to the comm directory, with some in the system directory.

The authors would be very interested in hearing about any of your successful
or unsucessful ports.

.SH LOCATION
 readme
