/* iset.c */
/* Fortran interface file */
#include "tools.h"

#ifdef POINTER_64_BITS
extern void *__ToPointer();
extern int __FromPointer();
extern void __RmPointer();
#else
#define __ToPointer(a) (a)
#define __FromPointer(a) (int)(a)
#define __RmPointer(a)
#endif

#include "set/iset.h"
#ifdef FORTRANCAPS
#define isenablecache_ ISENABLECACHE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define isenablecache_ isenablecache
#endif
 int  isenablecache_( n)
int*n;
{
return ISEnableCache(*n);
}
#ifdef FORTRANCAPS
#define isdisablecache_ ISDISABLECACHE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define isdisablecache_ isdisablecache
#endif
 void  isdisablecache_()
{
ISDisableCache();
}
#ifdef FORTRANCAPS
#define isalloc_ ISALLOC
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define isalloc_ isalloc
#endif
 int isalloc_( n)
int*n;
{
return __FromPointer( (void *)( ISAlloc(*n) ));
}
#ifdef FORTRANCAPS
#define iscreatefromdata_ ISCREATEFROMDATA
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define iscreatefromdata_ iscreatefromdata
#endif
 int iscreatefromdata_( n, idx)
int*n, *idx;
{
return __FromPointer( (void *)( ISCreateFromData(*n,idx) ));
}
#ifdef FORTRANCAPS
#define issetfromdata_ ISSETFROMDATA
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define issetfromdata_ issetfromdata
#endif
 void  issetfromdata_( is, n, idx)
ISet *is;
int*n, *idx;
{
ISSetFromData(
	(ISet* )__ToPointer( *(int*)(is) ),*n,idx);
}
#ifdef FORTRANCAPS
#define isdestroy_ ISDESTROY
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define isdestroy_ isdestroy
#endif
 void  isdestroy_( is)
ISet *is;
{
ISDestroy(
	(ISet* )__ToPointer( *(int*)(is) ));
}
#ifdef FORTRANCAPS
#define isunion_ ISUNION
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define isunion_ isunion
#endif
 void  isunion_( a, b, c)
ISet *a, *b, *c;
{
ISUnion(
	(ISet* )__ToPointer( *(int*)(a) ),
	(ISet* )__ToPointer( *(int*)(b) ),
	(ISet* )__ToPointer( *(int*)(c) ));
}
#ifdef FORTRANCAPS
#define isintersection_ ISINTERSECTION
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define isintersection_ isintersection
#endif
 void  isintersection_( a, b, c)
ISet *a, *b, *c;
{
ISIntersection(
	(ISet* )__ToPointer( *(int*)(a) ),
	(ISet* )__ToPointer( *(int*)(b) ),
	(ISet* )__ToPointer( *(int*)(c) ));
}
#ifdef FORTRANCAPS
#define isintersectionnotnull_ ISINTERSECTIONNOTNULL
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define isintersectionnotnull_ isintersectionnotnull
#endif
 int  isintersectionnotnull_( a, b)
ISet *a, *b;
{
return ISIntersectionNotNull(
	(ISet* )__ToPointer( *(int*)(a) ),
	(ISet* )__ToPointer( *(int*)(b) ));
}
#ifdef FORTRANCAPS
#define iscompintersection_ ISCOMPINTERSECTION
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define iscompintersection_ iscompintersection
#endif
 void  iscompintersection_( a, b, c)
ISet *a, *b, *c;
{
ISCompIntersection(
	(ISet* )__ToPointer( *(int*)(a) ),
	(ISet* )__ToPointer( *(int*)(b) ),
	(ISet* )__ToPointer( *(int*)(c) ));
}
#ifdef FORTRANCAPS
#define iscompress_ ISCOMPRESS
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define iscompress_ iscompress
#endif
 void  iscompress_( is)
ISet *is;
{
ISCompress(
	(ISet* )__ToPointer( *(int*)(is) ));
}
