/* file.c */
/* Fortran interface file */
#include "tools.h"
#include "system/system.h"

#ifdef POINTER_64_BITS
extern void *__ToPointer();
extern int __FromPointer();
extern void __RmPointer();
#else
#define __ToPointer(a) (a)
#define __FromPointer(a) (int)(a)
#define __RmPointer(a)
#endif

#ifdef FORTRANCAPS
#define sygetfullpath_ SYGETFULLPATH
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetfullpath_ sygetfullpath
#endif
 void  sygetfullpath_( path, fullpath, flen)
char *path, *fullpath;
int*flen;
{
SYGetFullPath(path,fullpath,*flen);
}
#ifdef FORTRANCAPS
#define sygetrelativepath_ SYGETRELATIVEPATH
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetrelativepath_ sygetrelativepath
#endif
 void  sygetrelativepath_( fullpath, path, flen)
char *path, *fullpath;
int*flen;
{
SYGetRelativePath(fullpath,path,*flen);
}
#ifdef FORTRANCAPS
#define sygetusername_ SYGETUSERNAME
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetusername_ sygetusername
#endif
 void  sygetusername_( name, nlen)
int*nlen;
char *name;
{
SYGetUserName(name,*nlen);
}
#ifdef FORTRANCAPS
#define sygethostname_ SYGETHOSTNAME
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygethostname_ sygethostname
#endif
 void  sygethostname_( name, nlen)
int*nlen;
char *name;
{
SYGetHostName(name,*nlen);
}
#ifdef FORTRANCAPS
#define sygetfilefrompath_ SYGETFILEFROMPATH
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetfilefrompath_ sygetfilefrompath
#endif
 int  sygetfilefrompath_( path, defname, name, fname, mode)
char   *path, *defname, *name, *fname,*mode;
{
return SYGetFileFromPath(path,defname,name,fname,*mode);
}
#ifdef FORTRANCAPS
#define sygetfilefromenvironment_ SYGETFILEFROMENVIRONMENT
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetfilefromenvironment_ sygetfilefromenvironment
#endif
 int  sygetfilefromenvironment_( env, defname, name, fname, mode)
char *env, *defname, *name, *fname,*mode;
{
return SYGetFileFromEnvironment(env,defname,name,fname,*mode);
}
#ifdef FORTRANCAPS
#define syopenwritablefile_ SYOPENWRITABLEFILE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define syopenwritablefile_ syopenwritablefile
#endif
 int syopenwritablefile_( dirpath, defname, name, fname, istmp)
char *dirpath, *defname, *name, *fname;
int*istmp;
{
return __FromPointer( (void *)( SYOpenWritableFile(dirpath,defname,name,fname,*istmp) ));
}
#ifdef FORTRANCAPS
#define sygetwd_ SYGETWD
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetwd_ sygetwd
#endif
 void  sygetwd_( path, len)
char *path;
int*len;
{
SYGetwd(path,*len);
}
#ifdef FORTRANCAPS
#define sygetrealpath_ SYGETREALPATH
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetrealpath_ sygetrealpath
#endif
 int sygetrealpath_( path, rpath)
char *path, *rpath;
{
return __FromPointer( (void *)( SYGetRealpath(path,rpath) ));
}
#ifdef FORTRANCAPS
#define syremovehomedir_ SYREMOVEHOMEDIR
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define syremovehomedir_ syremovehomedir
#endif
 void  syremovehomedir_( path)
char *path;
{
SYRemoveHomeDir(path);
}
#ifdef FORTRANCAPS
#define syismachinehost_ SYISMACHINEHOST
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define syismachinehost_ syismachinehost
#endif
 int  syismachinehost_( machinename)
char *machinename;
{
return SYIsMachineHost(machinename);
}
#ifdef FORTRANCAPS
#define syisdirectory_ SYISDIRECTORY
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define syisdirectory_ syisdirectory
#endif
 int  syisdirectory_( fname)
char  *fname;
{
return SYIsDirectory(fname);
}
#ifdef FORTRANCAPS
#define symakealldirs_ SYMAKEALLDIRS
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define symakealldirs_ symakealldirs
#endif
 void  symakealldirs_( name, fmode)
char *name;
int*fmode;
{
SYMakeAllDirs(name,*fmode);
}
#include <time.h>
#ifdef FORTRANCAPS
#define sylastchangetofile_ SYLASTCHANGETOFILE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sylastchangetofile_ sylastchangetofile
#endif
 void  sylastchangetofile_( fname, date, ltm)
char      *fname, *date;
struct tm *ltm;
{
SYLastChangeToFile(fname,date,
	(struct tm* )__ToPointer( *(int*)(ltm) ));
}
