/* rlimit.c */
/* Fortran interface file */
#include "tools.h"
#include "system/system.h"

#ifdef POINTER_64_BITS
extern void *__ToPointer();
extern int __FromPointer();
extern void __RmPointer();
#else
#define __ToPointer(a) (a)
#define __FromPointer(a) (int)(a)
#define __RmPointer(a)
#endif

#include <sys/time.h>
#ifdef FORTRANCAPS
#define sysetresourcelimits_ SYSETRESOURCELIMITS
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sysetresourcelimits_ sysetresourcelimits
#endif
 void  sysetresourcelimits_(mmem,mcpu,mpf,mtime)
int*mmem,*mcpu,*mpf;
struct timeval *mtime; 
{
SYSetResourceLimits(*mmem,*mcpu,*mpf,
	(struct timeval* )__ToPointer( *(int*)(mtime) ));
}
#ifdef FORTRANCAPS
#define sysetresourceclockoff_ SYSETRESOURCECLOCKOFF
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sysetresourceclockoff_ sysetresourceclockoff
#endif
 void  sysetresourceclockoff_()
{
SYSetResourceClockOff();
}
#ifdef FORTRANCAPS
#define sysetresourceclockon_ SYSETRESOURCECLOCKON
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sysetresourceclockon_ sysetresourceclockon
#endif
 void  sysetresourceclockon_()
{
SYSetResourceClockOn();
}
#ifdef FORTRANCAPS
#define sysetnice_ SYSETNICE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sysetnice_ sysetnice
#endif
 void  sysetnice_( n)
int*n;
{
SYSetNice(*n);
}
#ifdef FORTRANCAPS
#define sysetusertimerroutine_ SYSETUSERTIMERROUTINE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sysetusertimerroutine_ sysetusertimerroutine
#endif
 void  sysetusertimerroutine_( routine)
void (*routine)();
{
SYSetUserTimerRoutine(routine);
}
#ifdef FORTRANCAPS
#define sygetresourcevalues_ SYGETRESOURCEVALUES
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sygetresourcevalues_ sygetresourcevalues
#endif
 void  sygetresourcevalues_( mmem, mcpu, mpf, mtime)
int            *mmem, *mcpu, *mpf;
struct timeval *mtime; 
{
SYGetResourceValues(mmem,mcpu,mpf,
	(struct timeval* )__ToPointer( *(int*)(mtime) ));
}
#ifdef FORTRANCAPS
#define sysetrundownroutine_ SYSETRUNDOWNROUTINE
#elif !defined(FORTRANUNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define sysetrundownroutine_ sysetrundownroutine
#endif
 void  sysetrundownroutine_( ctx, routine)
void *ctx, (*routine)();
{
SYSetRundownRoutine(ctx,routine);
}
